package com.sun.jmx.snmp.internal;

import com.sun.jmx.snmp.SnmpMsg;
import com.sun.jmx.snmp.SnmpPdu;
import com.sun.jmx.snmp.SnmpBadSecurityLevelException;
import com.sun.jmx.snmp.SnmpUnknownSecModelException;
import com.sun.jmx.snmp.SnmpStatusException;
import java.net.InetAddress;
import com.sun.jmx.snmp.SnmpTooBigException;
import com.sun.jmx.snmp.SnmpSecurityParameters;

public interface SnmpIncomingRequest
{
    public abstract SnmpSecurityParameters getSecurityParameters();
    
    public abstract boolean isReport();
    
    public abstract boolean isResponse();
    
    public abstract void noResponse();
    
    public abstract String getPrincipal();
    
    public abstract int getSecurityLevel();
    
    public abstract int getSecurityModel();
    
    public abstract byte[] getContextName();
    
    public abstract byte[] getContextEngineId();
    
    public abstract byte[] getAccessContext();
    
    public abstract int encodeMessage(byte[] p0) throws SnmpTooBigException;
    
    public abstract void decodeMessage(byte[] p0, int p1, InetAddress p2, int p3) throws SnmpStatusException, SnmpUnknownSecModelException, SnmpBadSecurityLevelException;
    
    public abstract SnmpMsg encodeSnmpPdu(SnmpPdu p0, int p1) throws SnmpStatusException, SnmpTooBigException;
    
    public abstract SnmpPdu decodeSnmpPdu() throws SnmpStatusException;
    
    public abstract String printRequestMessage();
    
    public abstract String printResponseMessage();
}
